/**
 * MASKME Copyright (c) 2008-2013 by Abine, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Abine, Inc. ("Confidential Information"), subject
 * to the Non-Disclosure Agreement and/or License Agreement you entered
 * into with Abine. You shall use such Confidential Information only
 * in accordance with the terms of said Agreement(s). Abine makes
 * no representations or warranties about the suitability of the
 * software. The software is provided with ABSOLUTELY NO WARRANTY
 * and Abine will NOT BE LIABLE for ANY DAMAGES resulting from
 * the use of the software.
 *
 * Contact license@getabine.com with any license-related questions.
 *
 * https://www.abine.com
 * @license
 *
 */
var EXPORTED_SYMBOLS=EXPORTED_SYMBOLS||[];if("undefined"==typeof ABINEMASKME)try{Components.utils["import"]("resource://idme/content/global.js")}catch(e){dump(e),dump("\n")}ABINEMASKME.define("abine/contextMenu",["documentcloud/underscore","abine/core","abine/contextHelper","abine/eventLogger","abine/url","storage","abine/securityManager"],function(e,t,n,i,a,r,o){var s=t.BaseClass.extend({init:function(t,n){this.messenger=t;var i=n.getElementById("contentAreaContextMenu");i&&i.addEventListener("popupshowing",e.bind(this.refreshMenu,this),!1)},addClickHandlers:function(t,n){for(var i=t.getElementsByTagName("menuitem"),a=0;i.length>a;a++)i[a].onclick=e.bind(function(e){this.onClick(e,n)},this)},removeAllMenuItems:function(e,t){if(e&&(!t||e.getAttribute("id")==t))for(;e.hasChildNodes();)e.removeChild(e.firstChild)},addMenuItem:function(e,t,n){var i=e.createElement("menuitem");n.image&&i.setAttribute("class","menuitem-iconic");for(var a in n)i.setAttribute(a,n[a]);return t&&t.appendChild(i),i},addSubMenu:function(e,t,n){var i=e.createElement("menu");for(var a in n)i.setAttribute(a,n[a]);var r=e.createElement("menupopup");return r.setAttribute("id",n.id?n.id+"_popup":"popup"),i.appendChild(r),t.appendChild(i),r},addSeparator:function(e,t){var n=e.createElement("menuseparator");t.appendChild(n)},refreshMenu:function(t){if("contentAreaContextMenu"==t.target.id){var n=t.target.ownerDocument,i=n.popupNode,s=n.getElementById("abine_maskme_ContextMenu"),c="INPUT"!=i.tagName;s.hidden=c,c||r.Preference.findBy("key","hasRegistered",e.bind(function(t){if(!t||t.isFalse())return s.hidden=!0,void 0;var c=a.getTLD(i.ownerDocument.defaultView.location.href),l=n.getElementById("abine_maskme_context_root");if(c.indexOf("maskme://")>=0)return s.hidden=!0,void 0;try{var d=i.ownerDocument.defaultView.top.document.documentElement.abineTabId;this.alreadyRefreshing||(this.domain=c,this.alreadyRefreshing=!0,this.removeAllMenuItems(l),o.isLocked()?(this.addMenuItem(n,l,{label:"locked, click to unlock",id:"abine_maskme_unlock"}),this.addClickHandlers(l,d),this.alreadyRefreshing=!1):r.Site.showWithAccountsForDomain({params:[c]},e.bind(function(t){1==t.blacklisted||"1"==t.blacklisted?(this.addMenuItem(n,l,{label:"You have asked MaskMe to ignore this website",id:"abine_maskme_blacklisted"}),this.addClickHandlers(l,d),this.alreadyRefreshing=!1):this.createStaticMenu(n,l,e.bind(function(){this.createDynamicMenu(n,t,l,e.bind(function(){this.addClickHandlers(l,d),this.alreadyRefreshing=!1},this))},this))},this)))}catch(u){}},this))}},createStaticMenu:function(t,n,i){var a=this.addSubMenu(t,n,{label:"Email",id:"abine_maskme_email_parent"}),o=this.addSubMenu(t,n,{label:"Password",id:"abine_maskme_password_parent"}),s=this.addSubMenu(t,n,{label:"Phone",id:"abine_maskme_phone_parent"});r.Preference.findBy("key","entitledToPayments",e.bind(function(i){if(i&&i.isTrue()){var a=this.addSubMenu(t,n,{label:"Credit Card",id:"abine_maskme_card_parent"});r.Preference.findBy("key","hasEnabledPayments",e.bind(function(e){e&&e.isTrue()?this.addMenuItem(t,a,{label:"Mask my Credit Card",id:"abine_maskme_card_mask"}):this.addMenuItem(t,a,{label:"Activate Masked Cards",id:"abine_maskme_activate_card"})},this))}},this)),this.addMenuItem(t,a,{label:"Mask My Email",id:"abine_maskme_email_mask"}),this.addMenuItem(t,a,{label:"Use My Email",id:"abine_maskme_email_disclose"}),this.addMenuItem(t,o,{label:"Generate strong password",id:"abine_maskme_password_mask"}),e.async.series([e.bind(function(n){r.DisposablePhone.index(null,e.bind(function(e){e.length>0&&this.addMenuItem(t,s,{label:"Mask my Phone",id:"abine_maskme_phone_mask"}),n()},this))},this),e.bind(function(n){r.ShieldedPhone.index(null,e.bind(function(e){e.length>0?this.addMenuItem(t,s,{label:"Disclose my Phone",id:"abine_maskme_phone_disclose"}):this.addMenuItem(t,s,{label:"Set up your phone",id:"abine_maskme_setup_phone"}),n()},this))},this)],function(){i()})},createDynamicMenu:function(t,n,i,a){var r=this.addSubMenu(t,i,{label:"Logins for "+n.domain,id:"abine_maskme_logins"});if(0==n.accounts.length)this.addMenuItem(t,r,{label:"You have no accounts here",id:"abine_maskme_no_accounts"}),a();else{var o=!0;e.async.forEachSeries(n.accounts,e.bind(function(n,i){o||this.addSeparator(t,r);var a=null,s=null,c=null;e.each(n.accountFields,e.bind(function(e){"/contact/email"==e.dataType?a=e:"/nameperson/friendly"==e.dataType?s=e:"/password"==e.dataType&&(c=e,c.value=c.value.charAt(0)+"**********")},this)),a&&(o=!1,this.addMenuItem(t,r,{label:a.value,id:"abine_maskme_accountfield_"+a.id})),s&&(o=!1,this.addMenuItem(t,r,{label:s.value,id:"abine_maskme_accountfield_"+s.id})),c&&(o=!1,this.addMenuItem(t,r,{label:c.value,id:"abine_maskme_accountfield_"+c.id})),i()},this),function(e){e&&true&&ABINEMASKME.log.error("[ERROR CALLBACK]#[abine/firefox/context_menu]#[createDynamicMenu]# error while adding accounts to context menu"),a()})}},onClick:function(e,t){n.onClick(this.messenger,e.target.id,t,this.domain,e.target.ownerDocument.popupNode)},addLoginAccounts:function(){}});return{contextMenuHelper:new s}});